Bug 499019 - CRM 1908390 - BUG: warning at fs/inotify.c:181/set_dentry_child_flags()
Summary: CRM 1908390 - BUG: warning at fs/inotify.c:181/set_dentry_child_flags()
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel
Version: 5.2
Hardware: All
OS: Linux
urgent
medium
Target Milestone: rc
: ---
Assignee: Danny Feng
QA Contact: Red Hat Kernel QE team
URL:
Whiteboard:
Keywords: OtherQA, ZStream
: 520556 526853 545125 (view as bug list)
Depends On:
Blocks: 533192 525215 526775 533822 568662 568663
TreeView+ depends on / blocked
 
Reported: 2009-05-04 20:20 UTC by Issue Tracker
Modified: 2018-12-01 14:34 UTC (History)
17 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2010-03-30 06:51:28 UTC


Attachments (Terms of Use)
rhel5-158.el5 - inotify: fix race (2.08 KB, patch)
2009-07-14 21:36 UTC, Flavio Leitner
no flags Details | Diff
rhel5-158.el5 - inotify: remove debug code (2.47 KB, patch)
2009-07-14 21:39 UTC, Flavio Leitner
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2010:0178 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 5.5 kernel security and bug fix update 2010-03-29 12:18:21 UTC

Description Issue Tracker 2009-05-04 20:20:46 UTC
Escalated to Bugzilla from IssueTracker

Comment 9 Flavio Leitner 2009-07-14 21:36:09 UTC
Created attachment 351700 [details]
rhel5-158.el5 - inotify: fix race

Comment 10 Flavio Leitner 2009-07-14 21:39:40 UTC
Created attachment 351701 [details]
rhel5-158.el5 - inotify: remove debug code

Comment 14 Harshula Jayasuriya 2009-09-18 03:06:02 UTC
*** Bug 520556 has been marked as a duplicate of this bug. ***

Comment 15 RHEL Product and Program Management 2009-10-01 16:16:02 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.

Comment 18 Eric Paris 2009-10-19 14:56:08 UTC
*** Bug 526853 has been marked as a duplicate of this bug. ***

Comment 21 Chris Ward 2009-10-20 08:06:21 UTC
We need to confirm that there is commitment to test 
for the resolution of this request during the RHEL 5.5 Test
Phase, if it is accepted into the release. 

Please post a confirmation before Oct 23rd, 2009, 
including the contact information for testing engineers.

Comment 27 Flavio Leitner 2009-10-26 16:27:19 UTC
Description of problem:

Customer has reported that the following messages in his production box. 

Mar 31 17:51:13 kernel: 
BUG: warning at fs/inotify.c:181/set_dentry_child_flags() (Tainted: PF    )
Call Trace:
 [<ffffffff800ed831>] set_dentry_child_flags+0xef/0x14d
 [<ffffffff800ed8c7>] remove_watch_no_event+0x38/0x47
 [<ffffffff800ed8ee>] inotify_remove_watch_locked+0x18/0x3b
 [<ffffffff800ed9dc>] inotify_rm_wd+0x7e/0xa1
 [<ffffffff800edece>] sys_inotify_rm_watch+0x46/0x63
 [<ffffffff8005d116>] system_call+0x7e/0x83

BUG: warning at fs/inotify.c:181/set_dentry_child_flags() (Tainted: PF    )
Call Trace:
 [<ffffffff800ed831>] set_dentry_child_flags+0xef/0x14d
 [<ffffffff800ed8c7>] remove_watch_no_event+0x38/0x47
 [<ffffffff800ed8ee>] inotify_remove_watch_locked+0x18/0x3b
 [<ffffffff800ed9dc>] inotify_rm_wd+0x7e/0xa1
 [<ffffffff800edece>] sys_inotify_rm_watch+0x46/0x63
 [<ffffffff8005d116>] system_call+0x7e/0x83

BUG: warning at fs/inotify.c:181/set_dentry_child_flags() (Tainted: PF    )
Call Trace:
 [<ffffffff800ed831>] set_dentry_child_flags+0xef/0x14d
 [<ffffffff800ed8c7>] remove_watch_no_event+0x38/0x47
 [<ffffffff800ed8ee>] inotify_remove_watch_locked+0x18/0x3b
 [<ffffffff800ed9dc>] inotify_rm_wd+0x7e/0xa1
 [<ffffffff800edece>] sys_inotify_rm_watch+0x46/0x63
 [<ffffffff8005d116>] system_call+0x7e/0x83

current Kernel: 2.6.18-92.1.13.el5

cat proc/cpuinfo | grep processor | wc -l
16

Soon after these messages, syslog shows:
Mar 31 17:57:05 kernel: BUG: soft lockup - CPU#9 stuck for 10s! [java:9250]
Mar 31 17:57:09 kernel: BUG: soft lockup - CPU#8 stuck for 10s! [java:9245]
Mar 31 17:57:10 kernel: BUG: soft lockup - CPU#3 stuck for 10s! [snmpd:6501]
Mar 31 17:57:11 kernel: BUG: soft lockup - CPU#7 stuck for 10s! [perl:15683]
Mar 31 17:57:12 kernel: BUG: soft lockup - CPU#1 stuck for 10s! [vsftpd:15764]

From SAR of March31, Load average on the system is on the higher side. 
This could be reason for unresponsiveness

Following upstream patch seems to address the issue
http://www.kernel.org/pub/linux/kernel/people/akpm/patches/2.6/2.6.24-rc6/2.6.24-rc6-mm1/broken-out/inotify-fix-race.patch

Upstream patch from kernel bug 8938 seems to fit in cleanly with RHEL 5. 
http://bugzilla.kernel.org/show_bug.cgi?id=8938

How reproducible:
not known

Steps to Reproduce:
Not known

Actual results:
inotify race is seen

Expected results:
inotify race needs to be fixed

Comment 28 Don Zickus 2009-10-28 20:17:23 UTC
in kernel-2.6.18-171.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.

Comment 32 Sotiris Tsimbonis 2009-11-03 07:40:01 UTC
Installed kernel-2.6.18-171.el5 since 29 Oct, no sign of the message so far (it was quite frequent before)..

Comment 36 Frederik Ferner 2009-11-10 14:07:10 UTC
Same here, we've not seen any of the soft lockups or inotify warnings since we've installed the test kernel on Nov 3 on the machine where we've had soft lockups many times per day.

Comment 47 errata-xmlrpc 2010-03-30 06:51:28 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2010-0178.html

Comment 51 Josef Bacik 2010-09-09 16:56:33 UTC
*** Bug 545125 has been marked as a duplicate of this bug. ***


Note You need to log in before you can comment on or make changes to this bug.